/* --COPYRIGHT--,BSD
 * Copyright (c) 2016, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/


// Generated by Captivate Design Center v1_50_00_00 on Wed Sep 13 17:20:23 CDT 2017


//*****************************************************************************
// CAPT_UserConfig.c
//
// \version 1.10.03.04
// Released on July 12, 2017
//
//*****************************************************************************

//*****************************************************************************
//
// NOTE: This is an automatically generated source code file!  The Captivate
// Design Center generates the User Configuration file automatically based
// upon the sensor layout that was created.
//
// Changes to this file will be OVERWRITTEN if a you select
// "Update Existing Project" under "Generate Source Code" in the Design Center.
//
// To avoid interference with the code generation process, keep ALL application
// code external to this file.
//
//*****************************************************************************

#include "CAPT_UserConfig.h"

//*****************************************************************************
//
//! Captivate Element Definitions
//! All elements in this application are defined below.
//! Each element has 3 components:
//!  1) a raw count array (One index per freq. scanned) (uint16_t)
//!  2) a tuning array (One index per freq. scanned) (tCaptivateElementTuning)
//!  3) a element structure (tElement)
//
//*****************************************************************************
// Sensor: Mode, Element: E00
uint16_t Mode_E00_RawCnts[CAPT_SELF_FREQ_CNT];
tCaptivateElementTuning Mode_E00_Tuning[CAPT_SELF_FREQ_CNT];
tElement Mode_E00 =
{
    .ui8RxPin = 1,
    .ui8RxBlock = 1,
    .ui8TouchThreshold = 10,
    .pRawCount = Mode_E00_RawCnts,
    .pTuning = Mode_E00_Tuning,
};

// Sensor: Trackpad, Element: E00
uint16_t Trackpad_E00_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E00_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E00 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 1,
    .ui8RxPin = 0,
    .ui8RxBlock = 3,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E00_RawCnts,
    .pTuning = Trackpad_E00_Tuning,
};

// Sensor: Trackpad, Element: E01
uint16_t Trackpad_E01_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E01_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E01 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 1,
    .ui8RxPin = 0,
    .ui8RxBlock = 2,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E01_RawCnts,
    .pTuning = Trackpad_E01_Tuning,
};

// Sensor: Trackpad, Element: E02
uint16_t Trackpad_E02_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E02_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E02 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 1,
    .ui8RxPin = 0,
    .ui8RxBlock = 1,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E02_RawCnts,
    .pTuning = Trackpad_E02_Tuning,
};

// Sensor: Trackpad, Element: E03
uint16_t Trackpad_E03_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E03_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E03 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 1,
    .ui8RxPin = 3,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E03_RawCnts,
    .pTuning = Trackpad_E03_Tuning,
};

// Sensor: Trackpad, Element: E04
uint16_t Trackpad_E04_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E04_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E04 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 1,
    .ui8RxPin = 1,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E04_RawCnts,
    .pTuning = Trackpad_E04_Tuning,
};

// Sensor: Trackpad, Element: E05
uint16_t Trackpad_E05_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E05_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E05 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 2,
    .ui8RxPin = 0,
    .ui8RxBlock = 3,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E05_RawCnts,
    .pTuning = Trackpad_E05_Tuning,
};

// Sensor: Trackpad, Element: E06
uint16_t Trackpad_E06_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E06_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E06 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 2,
    .ui8RxPin = 0,
    .ui8RxBlock = 2,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E06_RawCnts,
    .pTuning = Trackpad_E06_Tuning,
};

// Sensor: Trackpad, Element: E07
uint16_t Trackpad_E07_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E07_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E07 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 2,
    .ui8RxPin = 0,
    .ui8RxBlock = 1,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E07_RawCnts,
    .pTuning = Trackpad_E07_Tuning,
};

// Sensor: Trackpad, Element: E08
uint16_t Trackpad_E08_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E08_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E08 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 2,
    .ui8RxPin = 3,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E08_RawCnts,
    .pTuning = Trackpad_E08_Tuning,
};

// Sensor: Trackpad, Element: E09
uint16_t Trackpad_E09_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E09_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E09 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 2,
    .ui8RxPin = 1,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E09_RawCnts,
    .pTuning = Trackpad_E09_Tuning,
};

// Sensor: Trackpad, Element: E10
uint16_t Trackpad_E10_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E10_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E10 =
{
    .ui8TxPin = 3,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 3,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E10_RawCnts,
    .pTuning = Trackpad_E10_Tuning,
};

// Sensor: Trackpad, Element: E11
uint16_t Trackpad_E11_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E11_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E11 =
{
    .ui8TxPin = 3,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 2,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E11_RawCnts,
    .pTuning = Trackpad_E11_Tuning,
};

// Sensor: Trackpad, Element: E12
uint16_t Trackpad_E12_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E12_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E12 =
{
    .ui8TxPin = 3,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 1,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E12_RawCnts,
    .pTuning = Trackpad_E12_Tuning,
};

// Sensor: Trackpad, Element: E13
uint16_t Trackpad_E13_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E13_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E13 =
{
    .ui8TxPin = 3,
    .ui8TxBlock = 3,
    .ui8RxPin = 3,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E13_RawCnts,
    .pTuning = Trackpad_E13_Tuning,
};

// Sensor: Trackpad, Element: E14
uint16_t Trackpad_E14_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E14_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E14 =
{
    .ui8TxPin = 3,
    .ui8TxBlock = 3,
    .ui8RxPin = 1,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E14_RawCnts,
    .pTuning = Trackpad_E14_Tuning,
};

// Sensor: Trackpad, Element: E15
uint16_t Trackpad_E15_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E15_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E15 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 3,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E15_RawCnts,
    .pTuning = Trackpad_E15_Tuning,
};

// Sensor: Trackpad, Element: E16
uint16_t Trackpad_E16_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E16_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E16 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 2,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E16_RawCnts,
    .pTuning = Trackpad_E16_Tuning,
};

// Sensor: Trackpad, Element: E17
uint16_t Trackpad_E17_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E17_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E17 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 1,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E17_RawCnts,
    .pTuning = Trackpad_E17_Tuning,
};

// Sensor: Trackpad, Element: E18
uint16_t Trackpad_E18_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E18_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E18 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 3,
    .ui8RxPin = 3,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E18_RawCnts,
    .pTuning = Trackpad_E18_Tuning,
};

// Sensor: Trackpad, Element: E19
uint16_t Trackpad_E19_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E19_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E19 =
{
    .ui8TxPin = 2,
    .ui8TxBlock = 3,
    .ui8RxPin = 1,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E19_RawCnts,
    .pTuning = Trackpad_E19_Tuning,
};

// Sensor: Trackpad, Element: E20
uint16_t Trackpad_E20_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E20_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E20 =
{
    .ui8TxPin = 1,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 3,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E20_RawCnts,
    .pTuning = Trackpad_E20_Tuning,
};

// Sensor: Trackpad, Element: E21
uint16_t Trackpad_E21_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E21_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E21 =
{
    .ui8TxPin = 1,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 2,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E21_RawCnts,
    .pTuning = Trackpad_E21_Tuning,
};

// Sensor: Trackpad, Element: E22
uint16_t Trackpad_E22_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E22_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E22 =
{
    .ui8TxPin = 1,
    .ui8TxBlock = 3,
    .ui8RxPin = 0,
    .ui8RxBlock = 1,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E22_RawCnts,
    .pTuning = Trackpad_E22_Tuning,
};

// Sensor: Trackpad, Element: E23
uint16_t Trackpad_E23_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E23_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E23 =
{
    .ui8TxPin = 1,
    .ui8TxBlock = 3,
    .ui8RxPin = 3,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E23_RawCnts,
    .pTuning = Trackpad_E23_Tuning,
};

// Sensor: Trackpad, Element: E24
uint16_t Trackpad_E24_RawCnts[CAPT_MUTUAL_FREQ_CNT];
tCaptivateElementTuning Trackpad_E24_Tuning[CAPT_MUTUAL_FREQ_CNT];
tElement Trackpad_E24 =
{
    .ui8TxPin = 1,
    .ui8TxBlock = 3,
    .ui8RxPin = 1,
    .ui8RxBlock = 0,
    .ui8TouchThreshold = 10,
    .pRawCount = Trackpad_E24_RawCnts,
    .pTuning = Trackpad_E24_Tuning,
};


//*****************************************************************************
//
//! Captivate Time Cycle Definitions
//! All time cycles in this application are defined below.  Time cycles are
//! groups of elements that are measured together in parallel in one time slot.
//! Each cycle has 2 components:
//!  1) an element pointer array to the member elements (tElement*)
//!  2) a cycle structure (tCycle)
//
//*****************************************************************************
// Time Cycle: Mode_C00
tElement* Mode_C00_Elements[1] =
{
    &Mode_E00,
};
tCycle Mode_C00 =
{
    .ui8NrOfElements = 1,
    .pElements = Mode_C00_Elements,
};

// Time Cycle: Trackpad_C00
tElement* Trackpad_C00_Elements[4] =
{
    &Trackpad_E00,
    &Trackpad_E01,
    &Trackpad_E02,
    &Trackpad_E03,
};
tCycle Trackpad_C00 =
{
    .ui8NrOfElements = 4,
    .pElements = Trackpad_C00_Elements,
};

// Time Cycle: Trackpad_C01
tElement* Trackpad_C01_Elements[1] =
{
    &Trackpad_E04,
};
tCycle Trackpad_C01 =
{
    .ui8NrOfElements = 1,
    .pElements = Trackpad_C01_Elements,
};

// Time Cycle: Trackpad_C02
tElement* Trackpad_C02_Elements[4] =
{
    &Trackpad_E05,
    &Trackpad_E06,
    &Trackpad_E07,
    &Trackpad_E08,
};
tCycle Trackpad_C02 =
{
    .ui8NrOfElements = 4,
    .pElements = Trackpad_C02_Elements,
};

// Time Cycle: Trackpad_C03
tElement* Trackpad_C03_Elements[1] =
{
    &Trackpad_E09,
};
tCycle Trackpad_C03 =
{
    .ui8NrOfElements = 1,
    .pElements = Trackpad_C03_Elements,
};

// Time Cycle: Trackpad_C04
tElement* Trackpad_C04_Elements[4] =
{
    &Trackpad_E10,
    &Trackpad_E11,
    &Trackpad_E12,
    &Trackpad_E13,
};
tCycle Trackpad_C04 =
{
    .ui8NrOfElements = 4,
    .pElements = Trackpad_C04_Elements,
};

// Time Cycle: Trackpad_C05
tElement* Trackpad_C05_Elements[1] =
{
    &Trackpad_E14,
};
tCycle Trackpad_C05 =
{
    .ui8NrOfElements = 1,
    .pElements = Trackpad_C05_Elements,
};

// Time Cycle: Trackpad_C06
tElement* Trackpad_C06_Elements[4] =
{
    &Trackpad_E15,
    &Trackpad_E16,
    &Trackpad_E17,
    &Trackpad_E18,
};
tCycle Trackpad_C06 =
{
    .ui8NrOfElements = 4,
    .pElements = Trackpad_C06_Elements,
};

// Time Cycle: Trackpad_C07
tElement* Trackpad_C07_Elements[1] =
{
    &Trackpad_E19,
};
tCycle Trackpad_C07 =
{
    .ui8NrOfElements = 1,
    .pElements = Trackpad_C07_Elements,
};

// Time Cycle: Trackpad_C08
tElement* Trackpad_C08_Elements[4] =
{
    &Trackpad_E20,
    &Trackpad_E21,
    &Trackpad_E22,
    &Trackpad_E23,
};
tCycle Trackpad_C08 =
{
    .ui8NrOfElements = 4,
    .pElements = Trackpad_C08_Elements,
};

// Time Cycle: Trackpad_C09
tElement* Trackpad_C09_Elements[1] =
{
    &Trackpad_E24,
};
tCycle Trackpad_C09 =
{
    .ui8NrOfElements = 1,
    .pElements = Trackpad_C09_Elements,
};


//*****************************************************************************
//
//! Captivate Sensor Definitions
//! All sensors in this application are defined below.  Sensors are
//! groups of time cycles that utilize raw measurement data to create an
//! abstract sensor type, such as a button, slider, wheel, or prox sensor.
//! Each sensor has 3 components:
//!  1) a cycle pointer array to the member time cycles (tCycle*)
//!  2) a sensor-specific parameter structure (tGenericSensorParams)
//!  3) a sensor structure (tSensor)
//
//*****************************************************************************
//Sensor: Mode
const tCycle* Mode_Cycles[1] =
{
    &Mode_C00,
};

tButtonSensorParams Mode_Params;
tSensor Mode =
{
    // Basic Properties
    .TypeOfSensor = eButtonGroup,
    .SensingMethod = eSelf,
    .DirectionOfInterest = eDOIDown,
    .pvCallback = NULL,
    .ui8NrOfCycles = 1,
    .pCycle = Mode_Cycles,
    .pSensorParams = (tGenericSensorParams*)&Mode_Params,
    // Conversion Control Parameters
    .ui16ConversionCount = 150,
    .ui16ConversionGain = 150,
    .ui8FreqDiv = 2,
    .ui8ChargeLength = 0,
    .ui8TransferLength = 0,
    .bModEnable = false,
    .ui8BiasControl = 3,
    .bCsDischarge = true,
    .bLpmControl = false,
    .ui8InputSyncControl = 0,
    .bTimerSyncControl = false,
    .bIdleState = true,
    // Tuning  Parameters
    .ui16ProxThreshold = 10,
    .ui16NegativeTouchThreshold = 20,
    .ui16ErrorThreshold = 8191,
    .ui16TimeoutThreshold = 1000,
    .ProxDbThreshold.DbIn = 1,
    .ProxDbThreshold.DbOut = 0,
    .TouchDbThreshold.DbIn = 1,
    .TouchDbThreshold.DbOut = 0,
    .bCountFilterEnable = true,
    .ui8CntBeta = 1,
    .bSensorHalt = false,
    .bPTSensorHalt = true,
    .bPTElementHalt = true,
    .ui8LTABeta = 7,
    .bReCalibrateEnable = true,
};

//Sensor: Trackpad
const tCycle* Trackpad_Cycles[10] =
{
    &Trackpad_C00,
    &Trackpad_C01,
    &Trackpad_C02,
    &Trackpad_C03,
    &Trackpad_C04,
    &Trackpad_C05,
    &Trackpad_C06,
    &Trackpad_C07,
    &Trackpad_C08,
    &Trackpad_C09,
};

tElement* Trackpad_Elements[5][5] =
{
    { &Trackpad_E00, &Trackpad_E01, &Trackpad_E02, &Trackpad_E03, &Trackpad_E04, },
    { &Trackpad_E05, &Trackpad_E06, &Trackpad_E07, &Trackpad_E08, &Trackpad_E09, },
    { &Trackpad_E10, &Trackpad_E11, &Trackpad_E12, &Trackpad_E13, &Trackpad_E14, },
    { &Trackpad_E15, &Trackpad_E16, &Trackpad_E17, &Trackpad_E18, &Trackpad_E19, },
    { &Trackpad_E20, &Trackpad_E21, &Trackpad_E22, &Trackpad_E23, &Trackpad_E24, },
};

uint16_t ui16TrackpadSumX[5];
uint16_t ui16TrackpadSumY[5];
tTrackPadSensorParams Trackpad_Params =
{
    .pvProcessSensor = NULL,
    .pvProcessGesture = NULL,
    .bReseed = false,
    .ui8Gesture = 0xFF,
    .bPresentTouch = false,
    .ui8TotalColumns = 5,
    .ui8TotalRows = 5,
    .pMatrix = Trackpad_Elements[0],
    .pSumX = ui16TrackpadSumX,
    .pSumY = ui16TrackpadSumY,
    .ui16Resolution_X = 1000,
    .ui16Resolution_Y = 1000,
    .ui16LowerTrim_X = 0,
    .ui16UpperTrim_X = 1000,
    .ui16LowerTrim_Y = 0,
    .ui16UpperTrim_Y = 1000,
    .ui16TopSpeed = 150,
    .ui16BottomSpeed = 10,
    .ui8LowerBeta = 10,
    .ui8TrackPadSensorBeta = 80,
    .ui16TapTime_Min = 4,
    .ui16TapTime_Max = 16,
    .ui16SwipeTime_Max = 10,
    .ui16DoubleTapTime_Max = 10,
    .ui16TapHoldTime_Min = 40,
    .ui16SwipeDistance_Min = 10,
    .bTrackPadFilterType = eDynamic,
    .bTrackPadFilterEnable = true,
};

tSensor Trackpad =
{
    // Basic Properties
    .TypeOfSensor = eTrackpad,
    .SensingMethod = eProjected,
    .DirectionOfInterest = eDOIUp,
    .pvCallback = NULL,
    .ui8NrOfCycles = 10,
    .pCycle = Trackpad_Cycles,
    .pSensorParams = (tGenericSensorParams*)&Trackpad_Params,
    // Conversion Control Parameters
    .ui16ConversionCount = 250,
    .ui16ConversionGain = 125,
    .ui8FreqDiv = 2,
    .ui8ChargeLength = 0,
    .ui8TransferLength = 0,
    .bModEnable = false,
    .ui8BiasControl = 3,
    .bCsDischarge = true,
    .bLpmControl = false,
    .ui8InputSyncControl = 0,
    .bTimerSyncControl = false,
    .bIdleState = true,
    // Tuning  Parameters
    .ui16ProxThreshold = 20,
    .ui16NegativeTouchThreshold = 20,
    .ui16ErrorThreshold = 8191,
    .ui16TimeoutThreshold = 65535,
    .ProxDbThreshold.DbIn = 1,
    .ProxDbThreshold.DbOut = 1,
    .TouchDbThreshold.DbIn = 1,
    .TouchDbThreshold.DbOut = 1,
    .bCountFilterEnable = true,
    .ui8CntBeta = 1,
    .bSensorHalt = false,
    .bPTSensorHalt = true,
    .bPTElementHalt = true,
    .ui8LTABeta = 7,
    .bReCalibrateEnable = true,
};


#if (CAPT_CONDUCTED_NOISE_IMMUNITY_ENABLE==true)
//*****************************************************************************
//
//! \var g_EMCConfig
//! This structure stores the EMC configuration for this application.
//
//*****************************************************************************
const tEMCConfig g_EMCConfig =
{
	// Conversion Style
	.selfModeConversionStyle = eMultiFrequency,
	.projModeConversionStyle = eMultiFrequencyWithOutlierRemoval,
	
	// Oversampling Style
	.selfModeOversamplingStyle = eNoOversampling,
	.projModeOversamplingStyle = eNoOversampling,
	
	// Jitter Filter Enable
	.bJitterFilterEnable = true,
	
	// Noise Thresholds and Calibration Noise Limits
	.ui8NoiseThreshold = 20,
	.ui16CalibrationNoiseLimit = 10,
	.ui8CalibrationTestSampleSize = 8,
		
	// Dynamic Threshold Adjustment Parameters
	.bEnableDynamicThresholdAdjustment = true,
	.ui8MaxRelThreshAdj = 76,
	.ui8NoiseLevelFilterEntryThresh = 40,
	.ui8NoiseLevelFilterExitThresh = 0,
	.ui8NoiseLevelFilterDown = 6,
	.ui8NoiseLevelFilterUp = 1,
	.coeffA = _IQ31(0.0065),
	.coeffB = _IQ31(0.050)
};
#endif

//*****************************************************************************
//
//! \var g_pCaptivateSensorArray
//! This array allows for indexed access to any
//! sensor in the configuration.
//
//*****************************************************************************
tSensor* g_pCaptivateSensorArray[CAPT_SENSOR_COUNT] =
{
    &Mode,
    &Trackpad,
};


//*****************************************************************************
//
//! \var g_uiApp
//! This structure stores the global settings for this application.
//
//*****************************************************************************
tCaptivateApplication g_uiApp =
{
    .state = eUIActive,
	.pSensorList = &g_pCaptivateSensorArray[0],
    .ui8NrOfSensors = CAPT_SENSOR_COUNT,
    .ui8AppLPM = LPM3_bits,
    .bElementDataTxEnable = true,
    .bSensorDataTxEnable = true,
    .ui16ActiveModeScanPeriod = 20,
    .ui16WakeOnProxModeScanPeriod = 100,
    .ui16InactivityTimeout = 32,
    .ui8WakeupInterval = 5,
};
